#include <windows.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <malloc.h>
#include <ctype.h>

//#include	"main.h"
#include	"shared.h"

///*************************************************
/// This file MUST NOT be modified, as ALL Series 80 Emulator
/// file-mapping apps (including the Emulator) MUST use the
/// common size and structure of the shared file-mapping!


/// See docs\Buddy.txt in the Emulator's folder for information about the Buddy system.


char	MapFileName[]="Local\\Series80EmulatorFileMap";
HANDLE	hMapFile=NULL;
/// NOTE: our pointer to the shared MAILBOX is declared as 'volatile' to avoid the C compiler's optimizer from optimizing out code we depend on (such as checking mailboxes in a tight loop)
volatile MAILBOX	*pMailBox=NULL;

/// NOTE: Each Buddy MUST set MailBoxNum to their proper (the first unused HWND) index upon return from StartShare()!

int		MailBoxNum;		// this Buddy's mailbox number (1-7)

///*************************************************
void StartShare() {

	BOOL	created=FALSE;

	hMapFile = OpenFileMapping(
					FILE_MAP_ALL_ACCESS,	// read/write access
					FALSE,					// do not inherit the name
					MapFileName);			// name of mapping object

	if( hMapFile==NULL ) {	/// not created yet, so create it
		hMapFile = CreateFileMapping(
					INVALID_HANDLE_VALUE,	// use paging file
					NULL,					// default security
					PAGE_READWRITE,			// read/write access
					0,						// maximum object size (high-order DWORD)
					BUF_SIZE,				// maximum object size (low-order DWORD)
					MapFileName);			// name of mapping object
		created = TRUE;						// should only happen once, by the first Emulator/Buddy that's run
	}
	if (hMapFile != NULL) {
		pMailBox = (MAILBOX*)MapViewOfFile(hMapFile,	// handle to map object
							FILE_MAP_ALL_ACCESS,	// read/write permission
							0,
							0,
							BUF_SIZE);
		if (pMailBox == NULL) {				// if failed, bail
			CloseHandle(hMapFile);
			hMapFile = NULL;
			return;
		}
		if( created ) memset((void *)pMailBox, 0, BUF_SIZE);	// should only happen once, by the first Emulator/Buddy that's run
   }
}

///*************************************************
void EndShare(BOOL sendGONE) {

	int		n;

	if( hMapFile!=NULL ) {
		if( pMailBox!=NULL ) {
			/// try to let the other end know that it's all over, but avoid possible lock-up
			if( sendGONE ) {
				if( !MailBoxNum ) {
					for(n=1; n<8; n++) if( pMailBox->hWnd[n] && !pMailBox->MsgE2B[n] ) pMailBox->MsgE2B[n] = BMSG_GONE;
				} else if( !pMailBox->MsgB2E[MailBoxNum] ) pMailBox->MsgB2E[MailBoxNum] = BMSG_GONE;
			}
			pMailBox->hWnd[MailBoxNum] = NULL;	// indicate we're no longer here
			UnmapViewOfFile((void*)pMailBox);			// release the view
			pMailBox = NULL;
		}
		CloseHandle(hMapFile);					// close the file
		hMapFile = NULL;
	}
}

